#include "utils.hpp"

char* read_file(const char* file_path) {
    std::ifstream file(file_path);
    if (!file) {
        std::cerr << "Could not open file: " << file_path << std::endl;
        return nullptr; // Return null if file cannot be opened
    }

    file.seekg(0, std::ios::end);
    size_t file_size = file.tellg();
    file.seekg(0, std::ios::beg);

    char* buffer = new char[file_size + 1];
    if (!buffer) {
        std::cerr << "Memory allocation failed" << std::endl;
        return nullptr;
    }

    file.read(buffer, file_size);
    buffer[file_size] = '\0'; // Null-terminate the string

    return buffer;
}